package dbifc

import Types._

import prototype.pdp._

trait DACMechanism {
  def check(u: User, q: SQLStmt): Option[String]
  def updatePolicy(u: User, q: SQLStmt): Unit
}

object DACMechanism {
  def pdpToDAC(pdp: IAccessControlMechanism): DACMechanism =
    new DACMechanism {
      def check(u: User, q: SQLStmt): Option[String] =
        pdp.authorizes(q, DB.v.system.getSystemState) match {
          case true => None
          case false => Some(s"PDP $pdp forbids query $q")
        }
      def updatePolicy(u: User, q: SQLStmt) = {}
    }
}
