package dbifc

import Types._

trait MonitorConfiguration[L] {
  // Basic lattice components:
  def top: L

  def bot: L

  def join(l1: L, l2: L): L

  def join(ls: Iterable[L]): L = ls.foldLeft(bot)(join)

  def meet(l1: L, l2: L): L

  def meet(ls: Iterable[L]): L = ls.foldLeft(top)(meet)

  def le(x: L, y : L): Boolean

  // specific to DB setting:
  def userLevel(u: User): L

  def queryLevel(q: SQLStmt, u: User): L

  // Can the attacker see query traffic?
  def queryVisible: Boolean
  // should we reset variable labels on policy changes?
  def forgetful: Boolean

  def cloneLevel(l: L): L

  // missing: initial monitor state, epoch predicates
}
